-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.classes = {}
lib.classevents = {}

function lib.defaults()
	cfg.FindPriority=nil
	cfg.Update=nil
	cfg.UpdateDOT=nil
	cfg.target='normal'
	cfg.class = select(2,UnitClass("player"))
	
	cfg.Power={}
	cfg.Power.now=UnitPower("player")
	cfg.Power.type=select(2,UnitPowerType("player"))
	cfg.Power.type_num=_G["SPELL_POWER_"..(select(2,UnitPowerType("player")))]
	cfg.Power.max=UnitPowerMax("player")
	cfg.Power.regen = (select(2,GetPowerRegen()))
	cfg.Power.real=cfg.Power.now
	cfg.Power.local_type=_G[cfg.Power.type]
	
	cfg.AltPower={}
	cfg.AltPower.now=0
	cfg.AltPower.max=0
	cfg.AltPower.type_num=cfg.Power.type_num
	cfg.AltPower.func=nil
	cfg.AltPower.local_type=nil
	
	cfg.local_casttime=hedlib.BlizzPattern(_G["SPELL_CAST_TIME_SEC"])
	cfg.local_cd=hedlib.BlizzPattern(_G["SPELL_RECAST_TIME_SEC"])
	cfg.lastUpdate=0
	cfg.nextUpdate=0
	
	cfg.pguid=UnitGUID("player")
	
	cfg.gcd=nil
	cfg.classfound=nil
	--cfg.now=GetTime()
	cfg.timeleft=0
	cfg.maxmintime = 21
	cfg.ctimeleft = cfg.maxmintime
	
	cfg.healthmax=UnitHealthMax("target")
	cfg.health=(cfg.healthmax==0) and 100 or hedlib.round(UnitHealth("target")*100/cfg.healthmax,0)
	
	cfg.phealthmax=UnitHealthMax("player")
	cfg.phealth=UnitHealth("player")
	cfg.phealthperc=(cfg.phealthmax==0) and 100 or hedlib.round(cfg.phealth*100/cfg.phealthmax,0)
	
	cfg.onupdate=nil
	cfg.onpower=nil
	cfg.onhealth=nil

	cfg.case = {}
	cfg.spells = {}
	cfg.spells_updating = {}
	cfg.sp_conv={}
	cfg.id2aura={}
	cfg.id2spell={}
	cfg.auras = {}
	cfg.auras_found={}
	cfg.plist = {}
	cfg.spellcast = {}
	cfg.lastspell_time=nil
	cfg.watchunits={}
	Heddevents = {}
	Heddclassevents = {}
	--cfg.combo = GetComboPoints('player', 'target')
	--cfg.holy = UnitPower("player" , SPELL_POWER_HOLY_POWER)
	cfg.mode=""
	cfg.set={}
	cfg.setitems={}
	cfg.equip={}
	cfg.trinket={}
	cfg.res_spells ={}
	cfg.haste=0
	cfg.res_spells ={
		[GetSpellInfo(75)]=true
		}
		
	cfg.Weapons={}
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	cfg.onGround = true
	cfg.spells_aoe={}
	cfg.spells_single={}
	cfg.spells_range={}
	
	cfg.heroism={[32182]=true,[2825]=true,[80353]=true,[90355]=true,[49016]=true,[178207]=true}
	cfg.DOTnum=0
	cfg.lastUpdateDOT=0
	cfg.TrackDOT=nil
	cfg.TargetsDOT={}
	cfg.maxDOTtick=3
	cfg.targetGUID=0
	cfg.TargetsBUFF={}
	cfg.shape="human"
	cfg.shapeid=GetShapeshiftFormID()
	cfg.cd_num=nil
	cfg.cd_last=nil
	cfg.CD={}
	cfg.cd_options=0
	cfg.dispell=nil
	cfg.dispell_player=nil
	cfg.dispell_target=nil
	cfg.dispell_player_type={}
	cfg.dispell_player_spell=nil
	cfg.dispell_target_type={}
	cfg.dispell_target_spell=nil
	cfg.Interrupt={}
	cfg.Interrupt.spell=nil
	cfg.Interrupt.name=nil
	cfg.Interrupt.caststart=nil
	cfg.Interrupt.castend=nil
	cfg.Interrupt.iscasting=nil
	cfg.Interrupt.castid=nil
	cfg.Interrupt.id=nil
	cfg.Interrupt.notInterruptible=true
	
	
	cfg.talents={}
	
	cfg.Casting={}
	cfg.Casting.name=nil
	cfg.Casting.caststart=nil
	cfg.Casting.castend=nil
	cfg.Casting.iscasting=nil
	cfg.Casting.cost=nil
	cfg.Casting.castid=nil
	cfg.Casting.id=nil
end
lib.defaults()

cfg.shapes={}
cfg.shapes={
[1]="Cat",
[2]="Tree",
--[3]="Travel",
--[4]="Aquatic",
[5]="Bear",
--[16]="Spirit Wolf",
[17]="Battle",
[18]="Defensive",
[19]="Berserker",
[22]="Metamorphosis",
--[27]="Flight",
[28]="Shadow",
[30]="Stealth",
[31]="Moonkin"
}

cfg.HasDOTEvent = {}
cfg.HasDOTEvent = {
	["SPELL_AURA_APPLIED"]=true,
	["SPELL_AURA_REFRESH"]=true,
	["SPELL_PERIODIC_DAMAGE"]=true,
	["SPELL_PERIODIC_HEAL"]=true,
	["SPELL_PERIODIC_MISSED"]=true
	}
