-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")

lib.HideFrame = function(frame)
	if frame then frame:Hide() end
end

lib.bdcolor = function(frame,color)
	if color then
		frame:SetBackdropColor(unpack(color))
		frame:SetBackdropBorderColor(unpack(color))
		frame:Show()
	else
		frame:Hide()
	end
end

lib.hideRuneFrame=function()
	RuneFrame:Hide()
	RuneFrame.Show = hedlib.dummy -- function() end
	RuneFrame.SetPoint = hedlib.dummy --function() end
	RuneFrame.ClearAllPoints = hedlib.dummy --function() end
	RuneFrame.SetAllPoints = hedlib.dummy --function() end
	RuneFrame:UnregisterEvent("RUNE_POWER_UPDATE");
	RuneFrame:UnregisterEvent("RUNE_TYPE_UPDATE");
	RuneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	RuneFrame:SetScript("OnEvent", nil);
	RuneFrame:SetParent(nil)
end

local lastUpdateBar = 0
lib.OnUpdateBar = function (self, elapsed) --Heddmain.bar=self
	elapsed = elapsed or 0
	lastUpdateBar = lastUpdateBar + elapsed
	if self.force or lastUpdateBar > cfg.freq then
		
		self.cd = self.cd - (GetTime() - self.start)
		self.cd = (self.cd>0) and self.cd or 0
		self.start=GetTime()

		if (self.cd>0) then
			self:Show()
			self:SetWidth(self.cd*cfg.scale)
--			print(self.spell,self.cd*cfg.scale)
		else
			self:SetWidth(0)
			self:Hide()
			self:SetScript("OnUpdate", nil)
		end

		lastUpdateBar = 0
		self.force=nil
	end	
end

lib.UpdateBar = function (spell, cd)
	cd =cd or 0
	Heddmain.bar.spell=spell
	Heddmain.bar.start = GetTime()
	Heddmain.bar.cd = cd
	if spell and cfg.spells[spell] then
		cfg.spells[spell].f:Show()
	end
	Heddmain.bar.force=true
	Heddmain.bar:SetScript("OnUpdate", lib.OnUpdateBar)
	lib.OnUpdateBar(Heddmain.bar)
	--cfg.nextUpdate=lib.GetSpellCDNext()
end

lib.nextUpdate = function(cd)
	if cd>0 and cfg.nextUpdate<(GetTime()+cd) then cfg.nextUpdate=GetTime()+cd end
	print(cfg.nextUpdate)
end

lib.SetSpellIcon = function(spell)
	cfg.spells[spell].f:SetWidth(cfg.isize)
	cfg.spells[spell].f:SetHeight(cfg.isize)
	cfg.spells[spell].f.texture = _G["HEDD_"..spell.."_text"] or cfg.spells[spell].f:CreateTexture("HEDD_"..spell.."_text","BACKGROUND")
	cfg.spells[spell].f.texture:SetAllPoints(cfg.spells[spell].f)
	if cfg.spells[spell].realid then
		cfg.spells[spell].f.texture:SetTexture(GetSpellTexture(cfg.spells[spell].realid))
	else
		cfg.spells[spell].f.texture:SetTexture(cfg.spells[spell].icon)
	end
	cfg.spells[spell].f:Hide()
end

lib.FrameResize = function(f,size)
	if not f then return end
	f:SetWidth(size)
	f:SetHeight(size)
end
lib.MainRefresh = function()
	lib.Hedd_slash("size "..(HeddDB.isize or cfg.isize))
	lib.Hedd_slash("bar "..(HeddDB.bsize or cfg.bsize))
	lib.Hedd_slash("text "..(HeddDB.tsize or cfg.tsize))
end

local slider
lib.SliderAdd = function(f,name,mi,ma,val,func)
	slider = CreateFrame("Slider", name, f, "OptionsSliderTemplate")
	slider:SetMinMaxValues(mi, ma)
	slider:SetValue(val)
	slider:SetValueStep(1)
	slider:SetObeyStepOnDrag(true)
	slider:SetWidth(cfg.slider_width)
	slider:SetScript("OnValueChanged", func)
	_G[name.."High"]:SetText(ma)
	_G[name.."Low"]:SetText(mi)
	_G[name.."Text"]:SetText(val)
	return slider
end

lib.SliderSet = function(slider,val)
	slider:SetValue(val)
	_G[slider:GetName().."Text"]:SetText(val)
end

local frame,icon
lib.AddIconButton = function(f,name,size,id,layer)
	frame = _G[name] or CreateFrame("Button",name,f)
	frame:SetWidth(size)
	frame:SetHeight(size)
	frame.texture = _G[name.."_texture"] or frame:CreateTexture(name.."_texture",layer or "BACKGROUND")
	frame.texture:SetAllPoints(frame)
	icon=select(3,GetSpellInfo(id))
	if icon then frame.texture:SetTexture(icon) end
	frame:Show()
	return frame
end

local cb 
lib.CheckboxAdd = function(f, name, caption,func)
    cb = CreateFrame("CheckButton", "$parent"..name, f, "OptionsCheckButtonTemplate")
    _G[cb:GetName().."Text"]:SetText(caption or name)
    cb:SetScript("OnClick", func)
    return cb
end