-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

cfg.move = false

local move = function()
	if ( cfg.move ) then
		Heddframe:RegisterForDrag("LeftButton")
		Heddframe:SetScript("OnDragStart", function(Heddframe) Heddframe:StartMoving() end)
		Heddframe:SetScript("OnDragStop", function(Heddframe) 
			Heddframe:StopMovingOrSizing()
			Heddframe:SetUserPlaced(true)
			local x, y = Heddframe:GetLeft(), Heddframe:GetBottom()
			end)
		Heddframe.move:Show()
		Heddframe.CD:RegisterForDrag("LeftButton")
		Heddframe.CD:SetScript("OnDragStart", function() Heddframe.CD:StartMoving() end)
		Heddframe.CD:SetScript("OnDragStop", function() 
			Heddframe.CD:StopMovingOrSizing()
			Heddframe.CD:SetUserPlaced(true)
		end)
		Heddframe.CD:EnableMouse(true)
		Heddframe.CD.texture:Show()
	else
		Heddframe:RegisterForDrag(nil)
		Heddframe:SetScript("OnDragStart", nil)
		Heddframe:SetScript("OnDragStop", nil)
		Heddframe.move:Hide()
		Heddframe.CD:RegisterForDrag(nil)
		Heddframe.CD:SetScript("OnDragStart", nil)
		Heddframe.CD:SetScript("OnDragStop", nil)
		Heddframe.CD:EnableMouse(nil)
		Heddframe.CD.texture:Hide()
	end
end

HEDDTOGGLELOCKED = function()
	cfg.move = not cfg.move
	move()
end

lib.Hedd_slash = function(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	
	if command=="move" then
		cfg.move = not cfg.move
		move()
	elseif command=="show" then
		if rest ~= "" then
			command, rest = rest:match("^(%S*)%s*(.-)$");
			if command=="allways" then
				HeddDB.show=command
				Heddmain:Show()
			elseif command=="incombat" then
				HeddDB.show=command
				if not InCombatLockdown() then
					Heddmain:Hide()
				end
			else
				print("Syntax: /hedd show [allways/incombat]");
			end
		else
			print("Syntax: /hedd show [allways/incombat]");
		end
	elseif command=="size" then
		if rest ~= "" then
			HeddDB.isize=tonumber(rest) or cfg.isize
			lib.FrameResize(Heddframe,HeddDB.isize)
			lib.FrameResize(Heddmain.DOT,HeddDB.isize)
			lib.FrameResize(Heddmain.BUFF,HeddDB.isize)
		else
			print("Syntax: /hedd size [1-9999]");
		end
	elseif command=="bar" then
		if rest ~= "" then
			HeddDB.bsize=tonumber(rest) or cfg.bsize
			Heddmain.bar:SetHeight(HeddDB.bsize)
		else
			print("Syntax: /hedd bar [1-9999]");
		end
	elseif command=="text" then
		if rest ~= "" then
			HeddDB.tsize=tonumber(rest) or cfg.tsize
			hedlib.UpdateFS(Heddmain.text,HeddDB.tsize)
			hedlib.UpdateFS(Heddmain.DOT.text,HeddDB.tsize)
			hedlib.UpdateFS(Heddmain.BUFF.text,HeddDB.tsize)
		else
			print("Syntax: /hedd text [1-9999]");
		end
	elseif command=="cd" then
		if rest ~= "" then
			command, rest = rest:match("^(%S*)%s*(.-)$");
			if command=="size" then
				if rest ~= "" then
					HeddDB.cdsize=tonumber(rest) or cfg.cdsize
					for index,name in pairs(cfg.spells) do
						lib.FrameResize(_G["HEDD_CD_"..index],HeddDB.cdsize)
					end
				else
					print("/hedd cd size [1-9999]");
				end
			elseif command=="hide" then
				if rest ~= "" then
					local spellid=tonumber(rest)
					if spellid and HeddDB.CD[spellid] then
						HeddDB.CD[spellid].hide=true
						lib.CDRefresh()
					end
				end
			elseif command=="show" then
				if rest ~= "" then
					local spellid=tonumber(rest)
					if spellid and HeddDB.CD[spellid] then
						HeddDB.CD[spellid].hide=false
						lib.CDRefresh()
					end
				end
			end
		else
			print("/hedd cd size [1-9999]");
		end
	else
		print("Syntax:")
		print("/hedd move")
		print("/hedd show [allways/incombat]");
		print("/hedd size [1-9999]")
		print("/hedd bar [1-9999]")
		print("/hedd text [1-9999]")
		print("/hedd cd size [1-9999]")
		print("/hedd cd hide [spellid]")
	end
	
end

Heddload = _G["HED_load"] or CreateFrame("Frame","HED_load",UIParent)
Heddload:Show()
Heddload:RegisterEvent("ADDON_LOADED")
local function Hedd_addon_load(self,event,arg1)
	if event == "ADDON_LOADED" and arg1 == "Hedd" then
		Heddload:UnregisterEvent("ADDON_LOADED")
		Heddload:SetScript("OnEvent",nil)
		Heddload:Hide()
		HeddDB = HeddDB or {}
		HeddDB.CD =HeddDB.CD or {}
		HeddDB.cdsize = HeddDB.cdsize or cfg.cdsize
		lib.MainRefresh()
		lib.Hedd_slash("cd size "..HeddDB.cdsize)
		HeddDB.show = HeddDB.show or "allways"
		lib.Hedd_slash("show "..HeddDB.show)
	end
end
Heddload:SetScript("OnEvent", Hedd_addon_load);

SLASH_HEDD1 = "/Hedd"
SLASH_HEDD2 = "/hedd"
SlashCmdList["HEDD"] = lib.Hedd_slash;

local O = addon .. "_OptionsPanel"
Heddframe.OptionsPanel = CreateFrame("Frame", O)
Heddframe.OptionsPanel.name=addon
local OptionsPanel = Heddframe.OptionsPanel

local title = OptionsPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetText(addon.." ("..GetAddOnMetadata(addon, "X-Curse-Packaged-Version")..")")
title:SetPoint("TOPLEFT", cfg.options_shift, -cfg.options_shift)

local ResetButton = CreateFrame("Button", nil, OptionsPanel, "OptionsButtonTemplate")
ResetButton:SetText("Reset")
ResetButton:SetPoint("TOPRIGHT", -cfg.options_shift, -cfg.options_shift)



local size_slider = lib.SliderAdd(OptionsPanel,O.."_isize",cfg.isize_min, cfg.isize_max,cfg.isize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.isize=v
	lib.FrameResize(_G[O.."_icondummy"],HeddDB.isize)
	lib.MainRefresh()
	end)
size_slider:SetPoint("TOPLEFT", title,"BOTTOMLEFT", 0, -30)
local size_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
size_lable:SetPoint("BOTTOMLEFT", size_slider,"TOPLEFT", 0, 0)
size_lable:SetText("Icon size:")

local move=lib.CheckboxAdd(OptionsPanel,"Move",nil,
	function(self)
	lib.Hedd_slash("move")
    end)

move:SetPoint("BOTTOMRIGHT", size_slider ,"TOPRIGHT")

local hide_incombat=lib.CheckboxAdd(OptionsPanel,"Hide in combat",nil,
	function(self)
	if self:GetChecked() then 
		lib.Hedd_slash("show incombat")
	else
		lib.Hedd_slash("show allways")
    end
end)
	
hide_incombat:SetPoint("BOTTOMRIGHT", move ,"TOPRIGHT")

local bar_slider = lib.SliderAdd(OptionsPanel,O.."_bsize",cfg.isize_min, cfg.isize_max,cfg.bsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.bsize=v
	_G[O.."_icondummy"].bar:SetHeight(HeddDB.bsize)
	lib.MainRefresh()
	end)
bar_slider:SetPoint("TOPLEFT", size_slider,"BOTTOMLEFT", 0, -30)
local bar_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
bar_lable:SetPoint("BOTTOMLEFT", bar_slider,"TOPLEFT", 0, 0)
bar_lable:SetText("Bar size:")

local text_slider = lib.SliderAdd(OptionsPanel,O.."_tsize",cfg.tsize_min, cfg.tsize_max,cfg.tsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.tsize=v
	lib.MainRefresh()
	hedlib.UpdateFS(_G[O.."_icondummy"].text,HeddDB.tsize)
	end)
text_slider:SetPoint("TOPLEFT", bar_slider,"BOTTOMLEFT", 0, -30)
local text_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
text_lable:SetPoint("BOTTOMLEFT", text_slider,"TOPLEFT", 0, 0)
text_lable:SetText("Text size:")

local icon_dummy = lib.AddIconButton(OptionsPanel,O.."_icondummy",cfg.isize,6603,"OVERLAY")
icon_dummy:SetPoint("TOPRIGHT", ResetButton,"BOTTOMRIGHT", 0, -10)
icon_dummy.text = icon_dummy.text or hedlib.CreateFont(OptionsPanel, cfg.textfont, cfg.tsize, "OUTLINE")
icon_dummy.text:SetPoint("TOP",icon_dummy,"BOTTOM")
icon_dummy.text:SetText("dps")
icon_dummy.bar=icon_dummy.bar or CreateFrame("StatusBar", O.."_bar", OptionsPanel)
icon_dummy.bar:SetWidth(20)
icon_dummy.bar:SetHeight(cfg.bsize)
icon_dummy.bar:SetStatusBarTexture(cfg.statusbar_texture)
icon_dummy.bar:SetStatusBarColor(124/255, 252/255, 0)
icon_dummy.bar:SetPoint("RIGHT",icon_dummy,"LEFT")
icon_dummy.bar:Show()

local cd_slider = lib.SliderAdd(OptionsPanel,O.."_cdsize",cfg.isize_min, cfg.isize_max,cfg.cdsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.cdsize=v
	lib.Hedd_slash("cd size "..(HeddDB.cdsize or cfg.cdsize))
	end)
cd_slider:SetPoint("TOPLEFT", text_slider,"BOTTOMLEFT", 0, -30)
local cd_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
cd_lable:SetPoint("BOTTOMLEFT", cd_slider,"TOPLEFT", 0, 0)
cd_lable:SetText("CD size:")

local cd_hide_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
cd_hide_lable:SetPoint("BOTTOMLEFT", OptionsPanel,"BOTTOMLEFT", cfg.options_shift, cfg.options_shift+cfg.isize+5)
cd_hide_lable:SetText("CD hide:")

OptionsPanel.refresh = function()
	icon_dummy.texture:SetTexture((select(3,GetSpellInfo(75))) or (select(3,GetSpellInfo(19881))) or (select(3,GetSpellInfo(6603))))
	lib.SliderSet(size_slider,HeddDB.isize)
	lib.FrameResize(icon_dummy,HeddDB.isize)
	lib.SliderSet(bar_slider,HeddDB.bsize)
	icon_dummy.bar:SetHeight(HeddDB.bsize)
	lib.SliderSet(text_slider,HeddDB.tsize)
	hedlib.UpdateFS(icon_dummy.text,HeddDB.tsize)
	lib.SliderSet(cd_slider,HeddDB.cdsize)
	if cfg.move then
		move:SetChecked(true)
	else
		move:SetChecked(nil)
	end
	hide_incombat:SetChecked(HeddDB.show=="incombat")
end

ResetButton:SetScript("OnClick", function()
	HeddDB={}
	HeddDB.CD={}
	HeddDB.isize=cfg.isize
	HeddDB.bsize=cfg.bsize
	HeddDB.tsize=cfg.tsize
	lib.MainRefresh()
	HeddDB.cdsize=cfg.cdsize
	lib.CDShowAll()
	lib.CDRefresh()
	OptionsPanel.refresh()
	lib.CDOptionsUncheckAll()
end)

Heddframe.OptionsPanel=OptionsPanel

InterfaceOptions_AddCategory(OptionsPanel)